#include once "libbass.bas"

if BASS.IsErrorOnLoad then
  print "error: while loading " & BASS_LIB_NAME
  beep:sleep:end 1
end if

type STREAM_INFO
  as single f,fStep
  as integer nSamplesOverAll
  as integer nSamples
end type

function SineProc BASS_API (byval handle as HSTREAM,byval pBuffer as any ptr,byval length as ulong,byval user as any ptr) as ulong
  dim as STREAM_INFO ptr info=user
  dim as single ptr pSamples=pBuffer
  if pSamples=0 or length<4 then delete info:return BASS_STREAMPROC_END
  dim as integer nSamples=length\sizeof(single)
  for i as integer=0 to nSamples-1
    pSamples[i]=sin(info->f)*.25
    info->f+=info->fStep
  next
  info->nSamples+=nSamples
  if info->nSamples>=info->nSamplesOverAll then delete info:return BASS_STREAMPROC_END
  return length
end function

sub BassBeep(byval freq as integer,byval ms as integer)
  if freq<50 then freq=50
  if ms<300 then ms=300
  dim as STREAM_INFO ptr info=new STREAM_INFO
  info->nSamplesOverAll=44100/1000*ms
  info->f=0
  info->fStep=6.28/44100.0*freq
  var stream=BASS.StreamCreate(44100, 1, BASS_SAMPLE_FLOAT or BASS_SAMPLE_SOFTWARE, @SineProc, info)
  if stream then BASS.ChannelPlay(stream,1)
end sub


BASS.Init()

BassBeep(440,1000)

dim as string key
print "press any key or [ESCAPE]"
while asc(key)<>27
  key=inkey()
  if len(key) andalso asc(key)<>27 then
    BassBeep(exp(.69314718055994530941*(int(20+rnd*60)/12)) * 27.5,300)
    while len(key):key=inkey():wend
  end if
  sleep 100
wend

