#include once "libbass.bas"

#define GET_HFILE(x) *cptr(integer ptr,x)

sub CloseCB BASS_API (byval user as any ptr)
  close #GET_HFILE(user)
end sub

function LenCB BASS_API (byval user as any ptr) as ULongInt
  return LOF(GET_HFILE(user))
end function

function ReadCB BASS_API (byval buffer as any ptr, byval length as ulong, byval user as any ptr) as ulong
  dim as integer hFile=*cptr(integer ptr,user)
  dim as uinteger nBytes
  dim as ubyte ptr p8=buffer
  get #GET_HFILE(user),,*p8,length,nBytes
  return nBytes
end function

function SeekCB BASS_API (byval offset as ULongInt, byval user as any ptr) as ulong
  dim as integer hFile=*cptr(integer ptr,user)
  offset+=1
  if offset>LOF(hFile) then return 0
  seek #GET_HFILE(user),offset
  return 1
end function

'
' main
'
dim as BASS_FILEPROCS callbacks = type(@CloseCB, @LenCB, @ReadCB, @SeekCB)
dim as integer hFile = FreeFile()

chdir exepath()

if BASS.IsErrorOnLoad then
  print "error: while loading " & BASS_LIB_NAME
  beep:sleep:end 1
end if

if BASS.Init()=0 then
  print "BASS.Init() error: " & BASS.GetErrorString() & " !"
  beep:sleep:end 1
end if

if open("legends.mp3",for binary,access read,as #hFile) then
  print "error: open('legends.mp3')"
  beep:sleep:end 1
end if

var stream = BASS.StreamCreateFileUser(STREAMFILE_NOBUFFER, 0, callbacks,@hFile)
if stream=0 then
  print "BASS_StreamCreateFileUser() error: " & BASS.GetErrorString() & " !"
  beep:sleep:end
end if

if BASS.ChannelPlay(stream,1) then
  print "streaming 'legends.mp3'"
else
  print "BASS.ChannelPlay() error: " & BASS.GetErrorString() & " !"
  beep:sleep:end
end if


print "press any key or wait on end of stream"
while inkey()="" andalso BASS.ChannelIsActive(stream)
  print "."; : sleep 250
wend 


