#ifndef __LIBBASS_BI__
#define __LIBBASS_BI__
/'
  BASS 2.4 C/C++ header file
  Copyright (c) 1999-2014 Un4seen Developments Ltd.

  See the BASS.CHM file for more detailed documentation
'/

' libBASS dynamic loader 2.4 FreeBASIC header file
' Copyright (c) 2015 Shiny3D.

#ifdef __FB_WIN32__
 #ifndef __FB_64BIT__
  #define BASS_LIB_NAME "win32/bass.dll"
 #else
  #define BASS_LIB_NAME "win64/bass.dll"
 #endif
#else
 #ifndef __FB_64BIT__
  #define BASS_LIB_NAME "linux32/libbass.so"
 #else
  #define BASS_LIB_NAME "linux64/libbass.so"
 #endif
#endif

#ifdef __FB_WIN32__
#define BASS_API stdcall 
#else
#define BASS_API cdecl
#endif

#define BASS_TRUE 1
#define BASS_FALSE 0

#ifndef MAKEWORD
#define MAKEWORD(a,b) Cast(ushort, ((a) And &hFF) Or ((b) Shl 8))
#endif
#ifndef MAKELONG
#define MAKELONG(a,b) Cast(ulong, ((a) And &hFFFF) Or ((b) Shl 16))
#endif

#define BASSVERSION &h204 ' API version
#define BASSVERSIONTEXT "2.4"

type HMUSIC   as ulong ' MOD music handle
type HSAMPLE  as ulong ' sample handle
type HCHANNEL as ulong ' playing sample's channel handle
type HSTREAM  as ulong ' sample stream handle
type HRECORD  as ulong ' recording handle
type HSYNC    as ulong ' synchronizer handle
type HDSP     as ulong ' DSP handle
type HFX      as ulong ' DX8 effect handle
type HPLUGIN  as ulong ' Plugin handle

' Error codes returned by BASS_ErrorGetCode
#define BASS_OK              0  ' all is OK
#define BASS_ERROR_MEM       1  ' memory error
#define BASS_ERROR_FILEOPEN  2  ' can't open the file
#define BASS_ERROR_DRIVER    3  ' can't find a free/valid driver
#define BASS_ERROR_BUFLOST   4  ' the sample buffer was lost
#define BASS_ERROR_HANDLE    5  ' invalid handle
#define BASS_ERROR_FORMAT    6  ' unsupported sample format
#define BASS_ERROR_POSITION  7  ' invalid position
#define BASS_ERROR_INIT      8  ' BASS_Init has not been successfully called
#define BASS_ERROR_START     9  ' BASS_Start has not been successfully called
#define BASS_ERROR_SSL      10  ' SSL/HTTPS support isn't available
#define BASS_ERROR_ALREADY  14  ' already initialized/paused/whatever
#define BASS_ERROR_NOCHAN   18  ' can't get a free channel
#define BASS_ERROR_ILLTYPE  19  ' an illegal type was specified
#define BASS_ERROR_ILLPARAM 20  ' an illegal parameter was specified
#define BASS_ERROR_NO3D     21  ' no 3D support
#define BASS_ERROR_NOEAX    22  ' no EAX support
#define BASS_ERROR_DEVICE   23  ' illegal device number
#define BASS_ERROR_NOPLAY   24  ' not playing
#define BASS_ERROR_FREQ     25  ' illegal sample rate
#define BASS_ERROR_NOTFILE  27  ' the stream is not a file stream
#define BASS_ERROR_NOHW     29  ' no hardware voices available
#define BASS_ERROR_EMPTY    31  ' the MOD music has no sequence data
#define BASS_ERROR_NONET    32  ' no internet connection could be opened
#define BASS_ERROR_CREATE   33  ' couldn't create the file
#define BASS_ERROR_NOFX     34  ' effects are not available
#define BASS_ERROR_NOTAVAIL 37  ' requested data is not available
#define BASS_ERROR_DECODE   38  ' the channel is/isn't a "decoding channel"
#define BASS_ERROR_DX       39  ' a sufficient DirectX version is not installed
#define BASS_ERROR_TIMEOUT  40  ' connection timedout
#define BASS_ERROR_FILEFORM 41  ' unsupported file format
#define BASS_ERROR_SPEAKER  42  ' unavailable speaker
#define BASS_ERROR_VERSION  43  ' invalid BASS version (used by add-ons)
#define BASS_ERROR_CODEC    44  ' codec is not available/supported
#define BASS_ERROR_ENDED    45  ' the channel/file has ended
#define BASS_ERROR_BUSY     46  ' the device is busy
#define BASS_ERROR_UNKNOWN  -1  ' some other mystery problem

' BASS_SetConfig options
#define BASS_CONFIG_BUFFER            0
#define BASS_CONFIG_UPDATEPERIOD      1
#define BASS_CONFIG_GVOL_SAMPLE       4
#define BASS_CONFIG_GVOL_STREAM       5
#define BASS_CONFIG_GVOL_MUSIC        6
#define BASS_CONFIG_CURVE_VOL         7
#define BASS_CONFIG_CURVE_PAN         8
#define BASS_CONFIG_FLOATDSP          9
#define BASS_CONFIG_3DALGORITHM      10
#define BASS_CONFIG_NET_TIMEOUT      11
#define BASS_CONFIG_NET_BUFFER       12
#define BASS_CONFIG_PAUSE_NOPLAY     13
#define BASS_CONFIG_NET_PREBUF       15
#define BASS_CONFIG_NET_PASSIVE      18
#define BASS_CONFIG_REC_BUFFER       19
#define BASS_CONFIG_NET_PLAYLIST     21
#define BASS_CONFIG_MUSIC_VIRTUAL    22
#define BASS_CONFIG_VERIFY           23
#define BASS_CONFIG_UPDATETHREADS    24
#define BASS_CONFIG_DEV_BUFFER       27
#define BASS_CONFIG_VISTA_TRUEPOS    30
#define BASS_CONFIG_IOS_MIXAUDIO     34
#define BASS_CONFIG_DEV_DEFAULT      36
#define BASS_CONFIG_NET_READTIMEOUT  37
#define BASS_CONFIG_VISTA_SPEAKERS   38
#define BASS_CONFIG_IOS_SPEAKER      39
#define BASS_CONFIG_MF_DISABLE       40
#define BASS_CONFIG_HANDLES          41
#define BASS_CONFIG_UNICODE          42
#define BASS_CONFIG_SRC              43
#define BASS_CONFIG_SRC_SAMPLE       44
#define BASS_CONFIG_ASYNCFILE_BUFFER 45
#define BASS_CONFIG_OGG_PRESCAN      47
#define BASS_CONFIG_MF_VIDEO         48
#define BASS_CONFIG_AIRPLAY          49
#define BASS_CONFIG_DEV_NONSTOP      50
#define BASS_CONFIG_IOS_NOCATEGORY   51
#define BASS_CONFIG_VERIFY_NET       52

' BASS_SetConfigPtr options
#define BASS_CONFIG_NET_AGENT        16
#define BASS_CONFIG_NET_PROXY        17
#define BASS_CONFIG_IOS_NOTIFY       46

' BASS_Init flags
#define BASS_DEVICE_8BITS           1 ' 8 bit resolution, else 16 bit
#define BASS_DEVICE_MONO            2 ' mono, else stereo
#define BASS_DEVICE_3D              4 ' enable 3D functionality
#define BASS_DEVICE_LATENCY     &H100 ' calculate device latency (BASS_INFO struct)
#define BASS_DEVICE_CPSPEAKERS  &H400 ' detect speakers via Windows control panel
#define BASS_DEVICE_SPEAKERS    &H800 ' force enabling of speaker assignment
#define BASS_DEVICE_NOSPEAKER  &H1000 ' ignore speaker arrangement
#define BASS_DEVICE_DMIX       &H2000 ' use ALSA "dmix" plugin
#define BASS_DEVICE_FREQ       &H4000 ' set device sample rate

' DirectSound interfaces (for use with BASS_GetDSoundObject)
#define BASS_OBJECT_DS     1 ' IDirectSound
#define BASS_OBJECT_DS3DL  2 ' IDirectSound3DListener

' Device info structure
type BASS_DEVICEINFO
  as zstring ptr name   ' description
  as zstring ptr driver ' driver
  as ulong       flags
end type

' BASS_DEVICEINFO state flags
#define BASS_DEVICE_ENABLED 1
#define BASS_DEVICE_DEFAULT 2
#define BASS_DEVICE_INIT    4
' BASS_DEVICEINFO features flags
#define BASS_DEVICE_TYPE_MASK        &Hff000000
#define BASS_DEVICE_TYPE_NETWORK     &H01000000
#define BASS_DEVICE_TYPE_SPEAKERS    &H02000000
#define BASS_DEVICE_TYPE_LINE        &H03000000
#define BASS_DEVICE_TYPE_HEADPHONES  &H04000000
#define BASS_DEVICE_TYPE_MICROPHONE  &H05000000
#define BASS_DEVICE_TYPE_HEADSET     &H06000000
#define BASS_DEVICE_TYPE_HANDSET     &H07000000
#define BASS_DEVICE_TYPE_DIGITAL     &H08000000
#define BASS_DEVICE_TYPE_SPDIF       &H09000000
#define BASS_DEVICE_TYPE_HDMI        &H0a000000
#define BASS_DEVICE_TYPE_DISPLAYPORT &H40000000

' BASS_GetDeviceInfo flags
#define BASS_DEVICES_AIRPLAY         &H1000000

type BASS_INFO
  as ulong flags     ' device capabilities (DSCAPS_xxx flags)
  as ulong hwsize    ' size of total device hardware memory
  as ulong hwfree    ' size of free device hardware memory
  as ulong freesam   ' number of free sample slots in the hardware
  as ulong free3d    ' number of free 3D sample slots in the hardware
  as ulong minrate   ' min sample rate supported by the hardware
  as ulong maxrate   ' max sample rate supported by the hardware
  as ulong eax        ' device supports EAX? (always BASS_FALSE if BASS_DEVICE_3D was not used)
  as ulong minbuf    ' recommended minimum buffer length in ms (requires BASS_DEVICE_LATENCY)
  as ulong dsver     ' DirectSound version
  as ulong latency   ' delay (in ms) before start of playback (requires BASS_DEVICE_LATENCY)
  as ulong initflags ' BASS_Init "flags" parameter
  as ulong speakers  ' number of speakers available
  as ulong freq      ' current output rate
end type

' BASS_INFO flags (from DSOUND.H)
#define DSCAPS_CONTINUOUSRATE  &H00000010  ' supports all sample rates between min/maxrate
#define DSCAPS_EMULDRIVER      &H00000020  ' device does NOT have hardware DirectSound support
#define DSCAPS_CERTIFIED       &H00000040  ' device driver has been certified by Microsoft
#define DSCAPS_SECONDARYMONO   &H00000100  ' mono
#define DSCAPS_SECONDARYSTEREO &H00000200  ' stereo
#define DSCAPS_SECONDARY8BIT   &H00000400  ' 8 bit
#define DSCAPS_SECONDARY16BIT  &H00000800  ' 16 bit

' Recording device info structure
type BASS_RECORDINFO
  as ulong flags    ' device capabilities (DSCCAPS_xxx flags)
  as ulong formats  ' supported standard formats (WAVE_FORMAT_xxx flags)
  as ulong inputs   ' number of inputs
  as ulong singlein  ' BASS_TRUE = only 1 input can be set at a time
  as ulong freq     ' current input rate
end type

' BASS_RECORDINFO flags (from DSOUND.H)
#define DSCCAPS_EMULDRIVER DSCAPS_EMULDRIVER  ' device does NOT have hardware DirectSound recording support
#define DSCCAPS_CERTIFIED  DSCAPS_CERTIFIED  ' device driver has been certified by Microsoft

' defines for formats field of BASS_RECORDINFO (from MMSYSTEM.H)
#ifndef WAVE_FORMAT_1M08
#define WAVE_FORMAT_1M08   &H00000001 ' 11.025 kHz, Mono,   8-bit
#define WAVE_FORMAT_1S08   &H00000002 ' 11.025 kHz, Stereo, 8-bit
#define WAVE_FORMAT_1M16   &H00000004 ' 11.025 kHz, Mono,   16-bit
#define WAVE_FORMAT_1S16   &H00000008 ' 11.025 kHz, Stereo, 16-bit
#define WAVE_FORMAT_2M08   &H00000010 ' 22.05  kHz, Mono,   8-bit
#define WAVE_FORMAT_2S08   &H00000020 ' 22.05  kHz, Stereo, 8-bit
#define WAVE_FORMAT_2M16   &H00000040 ' 22.05  kHz, Mono,   16-bit
#define WAVE_FORMAT_2S16   &H00000080 ' 22.05  kHz, Stereo, 16-bit
#define WAVE_FORMAT_4M08   &H00000100 ' 44.1   kHz, Mono,   8-bit
#define WAVE_FORMAT_4S08   &H00000200 ' 44.1   kHz, Stereo, 8-bit
#define WAVE_FORMAT_4M16   &H00000400 ' 44.1   kHz, Mono,   16-bit
#define WAVE_FORMAT_4S16   &H00000800 ' 44.1   kHz, Stereo, 16-bit
#endif

' Sample info structure
type BASS_SAMPLE
  as ulong  freq     ' default playback rate
  as single volume   ' default volume (0-1)
  as single pan      ' default pan (-1=left, 0=middle, 1=right)
  as ulong  flags    ' BASS_SAMPLE_xxx flags
  as ulong  length   ' length (in bytes)
  as ulong  max      ' maximum simultaneous playbacks
  as ulong  origres  ' original resolution bits
  as ulong  chans    ' number of channels
  as ulong  mingap   ' minimum gap (ms) between creating channels
  as ulong  mode3d   ' BASS_3DMODE_xxx mode
  as single mindist  ' minimum distance
  as single maxdist  ' maximum distance
  as ulong  iangle   ' angle of inside projection cone
  as ulong  oangle   ' angle of outside projection cone
  as single outvol   ' delta-volume outside the projection cone
  as ulong  vam      ' voice allocation/management flags (BASS_VAM_xxx)
  as ulong  priority ' priority (0=lowest, &Hffffffff=highest)
end type

#define BASS_SAMPLE_8BITS            1  ' 8 bit
#define BASS_SAMPLE_FLOAT          256  ' 32-bit floating-point
#define BASS_SAMPLE_MONO             2  ' mono
#define BASS_SAMPLE_LOOP             4  ' looped
#define BASS_SAMPLE_3D               8  ' 3D functionality
#define BASS_SAMPLE_SOFTWARE        16  ' not using hardware mixing
#define BASS_SAMPLE_MUTEMAX         32  ' mute at max distance (3D only)
#define BASS_SAMPLE_VAM             64  ' DX7 voice allocation & management
#define BASS_SAMPLE_FX             128  ' old implementation of DX8 effects
#define BASS_SAMPLE_OVER_VOL   &H10000  ' override lowest volume
#define BASS_SAMPLE_OVER_POS   &H20000  ' override longest playing
#define BASS_SAMPLE_OVER_DIST  &H30000  ' override furthest from listener (3D only)

#define BASS_STREAM_PRESCAN    &H20000  ' enable pin-point seeking/length (MP3/MP2/MP1)
#define BASS_MP3_SETPOS        BASS_STREAM_PRESCAN
#define BASS_STREAM_AUTOFREE   &H40000  ' automatically free the stream when it stop/ends
#define BASS_STREAM_RESTRATE   &H80000  ' restrict the download rate of internet file streams
#define BASS_STREAM_BLOCK      &H100000 ' download/play internet file stream in small blocks
#define BASS_STREAM_DECODE     &H200000 ' don't play the stream, only decode (BASS_ChannelGetData)
#define BASS_STREAM_STATUS     &H800000 ' give server status info (HTTP/ICY tags) in DOWNLOADPROC

#define BASS_MUSIC_FLOAT        BASS_SAMPLE_FLOAT
#define BASS_MUSIC_MONO         BASS_SAMPLE_MONO
#define BASS_MUSIC_LOOP         BASS_SAMPLE_LOOP
#define BASS_MUSIC_3D           BASS_SAMPLE_3D
#define BASS_MUSIC_FX           BASS_SAMPLE_FX
#define BASS_MUSIC_AUTOFREE     BASS_STREAM_AUTOFREE
#define BASS_MUSIC_DECODE       BASS_STREAM_DECODE
#define BASS_MUSIC_PRESCAN      BASS_STREAM_PRESCAN  ' calculate playback length
#define BASS_MUSIC_CALCLEN      BASS_MUSIC_PRESCAN
#define BASS_MUSIC_RAMP            &H200  ' normal ramping
#define BASS_MUSIC_RAMPS           &H400  ' sensitive ramping
#define BASS_MUSIC_SURROUND        &H800  ' surround sound
#define BASS_MUSIC_SURROUND2      &H1000  ' surround sound (mode 2)
#define BASS_MUSIC_FT2MOD         &H2000  ' play .MOD as FastTracker 2 does
#define BASS_MUSIC_PT1MOD         &H4000  ' play .MOD as ProTracker 1 does
#define BASS_MUSIC_NONINTER      &H10000  ' non-interpolated sample mixing
#define BASS_MUSIC_SINCINTER    &H800000  ' sinc interpolated sample mixing
#define BASS_MUSIC_POSRESET       &H8000  ' stop all notes when moving position
#define BASS_MUSIC_POSRESETEX   &H400000  ' stop all notes and reset bmp/etc when moving position
#define BASS_MUSIC_STOPBACK     &H80000   ' stop the music on a backwards jump effect
#define BASS_MUSIC_NOSAMPLE     &H100000  ' don't load the samples

' Speaker assignment flags
#define BASS_SPEAKER_FRONT      &H1000000  ' front speakers
#define BASS_SPEAKER_REAR       &H2000000  ' rear/side speakers
#define BASS_SPEAKER_CENLFE     &H3000000  ' center & LFE speakers (5.1)
#define BASS_SPEAKER_REAR2      &H4000000  ' rear center speakers (7.1)
#define BASS_SPEAKER_N(n) ((n) shl 24)  ' n'th pair of speakers (max 15)
#define BASS_SPEAKER_LEFT       &H10000000  ' modifier: left
#define BASS_SPEAKER_RIGHT      &H20000000  ' modifier: right
#define BASS_SPEAKER_FRONTLEFT  BASS_SPEAKER_FRONT  or BASS_SPEAKER_LEFT
#define BASS_SPEAKER_FRONTRIGHT BASS_SPEAKER_FRONT  or BASS_SPEAKER_RIGHT
#define BASS_SPEAKER_REARLEFT   BASS_SPEAKER_REAR   or BASS_SPEAKER_LEFT
#define BASS_SPEAKER_REARRIGHT  BASS_SPEAKER_REAR   or BASS_SPEAKER_RIGHT
#define BASS_SPEAKER_CENTER     BASS_SPEAKER_CENLFE or BASS_SPEAKER_LEFT
#define BASS_SPEAKER_LFE        BASS_SPEAKER_CENLFE or BASS_SPEAKER_RIGHT
#define BASS_SPEAKER_REAR2LEFT  BASS_SPEAKER_REAR2  or BASS_SPEAKER_LEFT
#define BASS_SPEAKER_REAR2RIGHT BASS_SPEAKER_REAR2  or BASS_SPEAKER_RIGHT

#define BASS_ASYNCFILE &H40000000
#define BASS_UNICODE   &H80000000

#define BASS_RECORD_PAUSE      &H8000  ' start recording paused
#define BASS_RECORD_ECHOCANCEL &H2000
#define BASS_RECORD_AGC        &H4000

' DX7 voice allocation & management flags
#define BASS_VAM_HARDWARE    1
#define BASS_VAM_SOFTWARE    2
#define BASS_VAM_TERM_TIME   4
#define BASS_VAM_TERM_DIST   8
#define BASS_VAM_TERM_PRIO  16

' Channel info structure
type BASS_CHANNELINFO
  as ulong   freq    ' default playback rate
  as ulong   chans   ' channels
  as ulong   flags   ' BASS_SAMPLE/STREAM/MUSIC/SPEAKER flags
  as ulong   ctype   ' type of channel
  as ulong   origres ' original resolution
  as HPLUGIN plugin  ' plugin
  as HSAMPLE sample  ' sample
  as const zstring  ptr filename ' filename
end type

' BASS_CHANNELINFO types
#define BASS_CTYPE_SAMPLE                 1
#define BASS_CTYPE_RECORD                 2
#define BASS_CTYPE_STREAM           &H10000
#define BASS_CTYPE_STREAM_OGG       &H10002
#define BASS_CTYPE_STREAM_MP1       &H10003
#define BASS_CTYPE_STREAM_MP2       &H10004
#define BASS_CTYPE_STREAM_MP3       &H10005
#define BASS_CTYPE_STREAM_AIFF      &H10006
#define BASS_CTYPE_STREAM_CA        &H10007
#define BASS_CTYPE_STREAM_MF        &H10008
#define BASS_CTYPE_STREAM_WAV       &H40000 ' WAVE flag, LOWORD=codec
#define BASS_CTYPE_STREAM_WAV_PCM   &H50001
#define BASS_CTYPE_STREAM_WAV_FLOAT &H50003
#define BASS_CTYPE_MUSIC_MOD        &H20000
#define BASS_CTYPE_MUSIC_MTM        &H20001
#define BASS_CTYPE_MUSIC_S3M        &H20002
#define BASS_CTYPE_MUSIC_XM         &H20003
#define BASS_CTYPE_MUSIC_IT         &H20004
#define BASS_CTYPE_MUSIC_MO3        &H00100 ' MO3 flag

type BASS_PLUGINFORM
  as ulong ctype            ' channel type
  as const zstring ptr name ' format description
  as const zstring ptr exts ' file extension filter (*.ext1;*.ext2;etc...)
end type

type BASS_PLUGININFO
  as ulong version                     ' version (same form as BASS_GetVersion)
  as ulong formatc                     ' number of formats
  as const BASS_PLUGINFORM ptr formats ' the array of formats
end type

type BASS_3DVECTOR
  as single x ' +=right, -=left
  as single y ' +=up   , -=down
  as single z ' +=front, -=behind
end type


' 3D channel modes
#define BASS_3DMODE_NORMAL   0 ' normal 3D processing
#define BASS_3DMODE_RELATIVE 1 ' position is relative to the listener
#define BASS_3DMODE_OFF      2 ' no 3D processing

' software 3D mixing algorithms (used with BASS_CONFIG_3DALGORITHM)
#define BASS_3DALG_DEFAULT   0
#define BASS_3DALG_OFF       1
#define BASS_3DALG_FULL      2
#define BASS_3DALG_LIGHT     3

' EAX environments, use with BASS_SetEAXParameters
' EAX environments, use with BASS_SetEAXParameters
enum
  EAX_ENVIRONMENT_GENERIC,
  EAX_ENVIRONMENT_PADDEDCELL,
  EAX_ENVIRONMENT_ROOM,
  EAX_ENVIRONMENT_BATHROOM,
  EAX_ENVIRONMENT_LIVINGROOM,
  EAX_ENVIRONMENT_STONEROOM,
  EAX_ENVIRONMENT_AUDITORIUM,
  EAX_ENVIRONMENT_CONCERTHALL,
  EAX_ENVIRONMENT_CAVE,
  EAX_ENVIRONMENT_ARENA,
  EAX_ENVIRONMENT_HANGAR,
  EAX_ENVIRONMENT_CARPETEDHALLWAY,
  EAX_ENVIRONMENT_HALLWAY,
  EAX_ENVIRONMENT_STONECORRIDOR,
  EAX_ENVIRONMENT_ALLEY,
  EAX_ENVIRONMENT_FOREST,
  EAX_ENVIRONMENT_CITY,
  EAX_ENVIRONMENT_MOUNTAINS,
  EAX_ENVIRONMENT_QUARRY,
  EAX_ENVIRONMENT_PLAIN,
  EAX_ENVIRONMENT_PARKINGLOT,
  EAX_ENVIRONMENT_SEWERPIPE,
  EAX_ENVIRONMENT_UNDERWATER,
  EAX_ENVIRONMENT_DRUGGED,
  EAX_ENVIRONMENT_DIZZY,
  EAX_ENVIRONMENT_PSYCHOTIC,
  EAX_ENVIRONMENT_COUNT      ' total number of environments
end enum

' EAX presets, usage: BASS_SetEAXParameters(EAX_PRESET_xxx)
#define EAX_PRESET_GENERIC         EAX_ENVIRONMENT_GENERIC,0.5F,1.493F,0.5F
#define EAX_PRESET_PADDEDCELL      EAX_ENVIRONMENT_PADDEDCELL,0.25F,0.1F,0.0F
#define EAX_PRESET_ROOM            EAX_ENVIRONMENT_ROOM,0.417F,0.4F,0.666F
#define EAX_PRESET_BATHROOM        EAX_ENVIRONMENT_BATHROOM,0.653F,1.499F,0.166F
#define EAX_PRESET_LIVINGROOM      EAX_ENVIRONMENT_LIVINGROOM,0.208F,0.478F,0.0F
#define EAX_PRESET_STONEROOM       EAX_ENVIRONMENT_STONEROOM,0.5F,2.309F,0.888F
#define EAX_PRESET_AUDITORIUM      EAX_ENVIRONMENT_AUDITORIUM,0.403F,4.279F,0.5F
#define EAX_PRESET_CONCERTHALL     EAX_ENVIRONMENT_CONCERTHALL,0.5F,3.961F,0.5F
#define EAX_PRESET_CAVE            EAX_ENVIRONMENT_CAVE,0.5F,2.886F,1.304F
#define EAX_PRESET_ARENA           EAX_ENVIRONMENT_ARENA,0.361F,7.284F,0.332F
#define EAX_PRESET_HANGAR          EAX_ENVIRONMENT_HANGAR,0.5F,10.0F,0.3F
#define EAX_PRESET_CARPETEDHALLWAY EAX_ENVIRONMENT_CARPETEDHALLWAY,0.153F,0.259F,2.0F
#define EAX_PRESET_HALLWAY         EAX_ENVIRONMENT_HALLWAY,0.361F,1.493F,0.0F
#define EAX_PRESET_STONECORRIDOR   EAX_ENVIRONMENT_STONECORRIDOR,0.444F,2.697F,0.638F
#define EAX_PRESET_ALLEY           EAX_ENVIRONMENT_ALLEY,0.25F,1.752F,0.776F
#define EAX_PRESET_FOREST          EAX_ENVIRONMENT_FOREST,0.111F,3.145F,0.472F
#define EAX_PRESET_CITY            EAX_ENVIRONMENT_CITY,0.111F,2.767F,0.224F
#define EAX_PRESET_MOUNTAINS       EAX_ENVIRONMENT_MOUNTAINS,0.194F,7.841F,0.472F
#define EAX_PRESET_QUARRY          EAX_ENVIRONMENT_QUARRY,1.0F,1.499F,0.5F
#define EAX_PRESET_PLAIN           EAX_ENVIRONMENT_PLAIN,0.097F,2.767F,0.224F
#define EAX_PRESET_PARKINGLOT      EAX_ENVIRONMENT_PARKINGLOT,0.208F,1.652F,1.5F
#define EAX_PRESET_SEWERPIPE       EAX_ENVIRONMENT_SEWERPIPE,0.652F,2.886F,0.25F
#define EAX_PRESET_UNDERWATER      EAX_ENVIRONMENT_UNDERWATER,1.0F,1.499F,0.0F
#define EAX_PRESET_DRUGGED         EAX_ENVIRONMENT_DRUGGED,0.875F,8.392F,1.388F
#define EAX_PRESET_DIZZY           EAX_ENVIRONMENT_DIZZY,0.139F,17.234F,0.666F
#define EAX_PRESET_PSYCHOTIC       EAX_ENVIRONMENT_PSYCHOTIC,0.486F,7.563F,0.806F

/' User stream callback function. NOTE: A stream function should obviously be as quick
   as possible, other streams (and MOD musics) can't be mixed until it's finished.
   handle : The stream that needs writing
   buffer : Buffer to write the samples in
   length : Number of bytes to write
   user   : The 'user' parameter value given when calling BASS_StreamCreate
  RETURN : Number of bytes written. Set the BASS_STREAMPROC_END flag to end the stream. '/
type STREAMPROC as function BASS_API (byval handle as HSTREAM, byval buffer as any ptr, byval length as ulong, byval user as any ptr) as ulong


#define BASS_STREAMPROC_END &h80000000  ' end of user stream flag

#define STREAMPROC_DUMMY Cast(STREAMPROC Ptr,  0) ' "dummy" stream
#define STREAMPROC_PUSH  Cast(STREAMPROC Ptr, -1) ' push stream

' BASS_StreamCreateFileUser file systems
#define STREAMFILE_NOBUFFER   0
#define STREAMFILE_BUFFER     1
#define STREAMFILE_BUFFERPUSH 2

' User file stream callback functions
type FILECLOSEPROC as sub      BASS_API (byval user as any ptr)
type FILELENPROC   as function BASS_API (byval user as any ptr) as ULongInt
type FILEREADPROC  as function BASS_API (byval buffer as any ptr, byval length as ulong, byval user as any ptr) as ulong
type FILESEEKPROC  as function BASS_API (byval offset as ULongInt, byval user as any ptr) as ulong

type BASS_FILEPROCS
  as FILECLOSEPROC close
  as FILELENPROC   length
  as FILEREADPROC  read
  as FILESEEKPROC  seek
end type

' BASS_StreamPutFileData options
#define BASS_FILEDATA_END 0 ' end & close the file

' BASS_StreamGetFilePosition modes
#define BASS_FILEPOS_CURRENT 0
#define BASS_FILEPOS_DECODE 0
#define BASS_FILEPOS_DOWNLOAD 1
#define BASS_FILEPOS_END 2
#define BASS_FILEPOS_START 3
#define BASS_FILEPOS_CONNECTED 4
#define BASS_FILEPOS_BUFFER 5
#define BASS_FILEPOS_SOCKET 6

/' Internet stream download callback function.
   buffer : Buffer containing the downloaded data... NULL=end of download
   length : Number of bytes in the buffer
   user   : The 'user' parameter value given when calling BASS_StreamCreateURL '/
type DOWNLOADPROC as sub BASS_API (byval buffer as const any ptr, byval length as ulong, byval user as any ptr)

' BASS_ChannelSetSync types
#define BASS_SYNC_POS         0
#define BASS_SYNC_MUSICINST   1
#define BASS_SYNC_END         2
#define BASS_SYNC_MUSICFX     3
#define BASS_SYNC_META        4
#define BASS_SYNC_SLIDE       5
#define BASS_SYNC_STALL       6
#define BASS_SYNC_DOWNLOAD    7
#define BASS_SYNC_FREE        8
#define BASS_SYNC_MUSICPOS   10
#define BASS_SYNC_SETPOS     11
#define BASS_SYNC_OGG_CHANGE 12
#define BASS_SYNC_MIXTIME    &H40000000  ' FLAG: sync at mixtime, else at playtime
#define BASS_SYNC_ONETIME    &H80000000  ' FLAG: sync only once, else continuously

/' Sync callback function. NOTE: a sync callback function should be very quick 
   as other syncs can't be processed until it has finished.
   If the sync is a "mixtime" sync, then other streams and MOD musics can't be mixed until it's finished either.
   handle : The sync that has occured
   channel: Channel that the sync occured in
   data   : Additional data associated with the sync's occurance
   user   : The 'user' parameter given when calling BASS_ChannelSetSync '/
type SYNCPROC as sub BASS_API (byval handle as HSYNC, byval channel as ulong, byval data as ulong, byval user as any ptr)

/' DSP callback function. NOTE: A DSP function should obviously be as quick as possible... 
   other DSP functions, streams and MOD musics can not be processed until it's finished.
   handle : The DSP handle
   channel: Channel that the DSP is being applied to
   buffer : Buffer to apply the DSP to
   length : Number of bytes in the buffer
   user   : The 'user' parameter given when calling BASS_ChannelSetDSP '/
type DSPPROC as sub BASS_API (byval handle as HDSP, byval channel as ulong, byval buffer as any ptr, byval length as ulong, byval user as any ptr)

/' Recording callback function.
  handle : The recording handle
  buffer : Buffer containing the recorded sample data
  length : Number of bytes
  user   : The 'user' parameter value given when calling BASS_RecordStart
  RETURN : BASS_TRUE = continue recording, BASS_FALSE = stop '/
type RECORDPROC as function BASS_API (byval handle as HRECORD, byval buffer as const any ptr, byval length as ulong, byval user as any ptr) as ulong

' BASS_ChannelIsActive return values
#define BASS_ACTIVE_STOPPED  0
#define BASS_ACTIVE_PLAYING  1
#define BASS_ACTIVE_STALLED  2
#define BASS_ACTIVE_PAUSED  3


' Channel attributes
#define BASS_ATTRIB_FREQ                 1
#define BASS_ATTRIB_VOL                  2
#define BASS_ATTRIB_PAN                  3
#define BASS_ATTRIB_EAXMIX               4
#define BASS_ATTRIB_NOBUFFER             5
#define BASS_ATTRIB_VBR                  6
#define BASS_ATTRIB_CPU                  7
#define BASS_ATTRIB_SRC                  8
#define BASS_ATTRIB_NET_RESUME           9
#define BASS_ATTRIB_SCANINFO            10

#define BASS_ATTRIB_MUSIC_AMPLIFY    &H100
#define BASS_ATTRIB_MUSIC_PANSEP     &H101
#define BASS_ATTRIB_MUSIC_PSCALER    &H102
#define BASS_ATTRIB_MUSIC_BPM        &H103
#define BASS_ATTRIB_MUSIC_SPEED      &H104
#define BASS_ATTRIB_MUSIC_VOL_GLOBAL &H105
#define BASS_ATTRIB_MUSIC_ACTIVE     &H106
#define BASS_ATTRIB_MUSIC_VOL_CHAN   &H200 ' + channel #
#define BASS_ATTRIB_MUSIC_VOL_INST   &H300 ' + instrument #

' BASS_ChannelGetData flags
#define BASS_DATA_AVAILABLE               0  ' query how much data is buffered
#define BASS_DATA_FIXED          &H20000000  ' flag: return 8.24 fixed-point data
#define BASS_DATA_FLOAT          &H40000000  ' flag: return floating-point sample data
#define BASS_DATA_FFT256         &H80000000  '   256 FFT samples
#define BASS_DATA_FFT512         &H80000001  '   512 FFT samples
#define BASS_DATA_FFT1024        &H80000002  '  1024 FFT samples
#define BASS_DATA_FFT2048        &H80000003  '  2048 FFT samples
#define BASS_DATA_FFT4096        &H80000004  '  4096 FFT samples
#define BASS_DATA_FFT8192        &H80000005  '  8192 FFT samples
#define BASS_DATA_FFT16384       &H80000006  ' 16384 FFT samples
#define BASS_DATA_FFT_INDIVIDUAL       &H10  ' FFT flag: FFT for each channel, else all combined
#define BASS_DATA_FFT_NOWINDOW         &H20  ' FFT flag: no Hanning window
#define BASS_DATA_FFT_REMOVEDC         &H40  ' FFT flag: pre-remove DC bias
#define BASS_DATA_FFT_COMPLEX          &H80  ' FFT flag: return complex data

' BASS_ChannelGetLevelEx flags
#define BASS_LEVEL_MONO    1
#define BASS_LEVEL_STEREO  2
#define BASS_LEVEL_RMS     4

' BASS_ChannelGetTags types : what's returned
#define BASS_TAG_ID3                 0 ' ID3v1 tags : TAG_ID3 structure
#define BASS_TAG_ID3V2               1 ' ID3v2 tags : variable length block
#define BASS_TAG_OGG                 2 ' OGG comments : series of null-terminated UTF-8 strings
#define BASS_TAG_HTTP                3 ' HTTP headers : series of null-terminated ANSI strings
#define BASS_TAG_ICY                 4 ' ICY headers : series of null-terminated ANSI strings
#define BASS_TAG_META                5 ' ICY metadata : ANSI string
#define BASS_TAG_APE                 6 ' APE tags : series of null-terminated UTF-8 strings
#define BASS_TAG_MP4                 7 ' MP4/iTunes metadata : series of null-terminated UTF-8 strings
#define BASS_TAG_VENDOR              9 ' OGG encoder : UTF-8 string
#define BASS_TAG_LYRICS3            10 ' Lyric3v2 tag : ASCII string
#define BASS_TAG_CA_CODEC           11 ' CoreAudio codec info : TAG_CA_CODEC structure
#define BASS_TAG_MF                 13 ' Media Foundation tags : series of null-terminated UTF-8 strings
#define BASS_TAG_WAVEFORMAT         14 ' WAVE format : WAVEFORMATEEX structure
#define BASS_TAG_RIFF_INFO       &H100 ' RIFF "INFO" tags : series of null-terminated ANSI strings
#define BASS_TAG_RIFF_BEXT       &H101 ' RIFF/BWF "bext" tags : TAG_BEXT structure
#define BASS_TAG_RIFF_CART       &H102 ' RIFF/BWF "cart" tags : TAG_CART structure
#define BASS_TAG_RIFF_DISP       &H103 ' RIFF "DISP" text tag : ANSI string
#define BASS_TAG_APE_BINARY     &H1000 ' + index #, binary APE tag : TAG_APE_BINARY structure

#define BASS_TAG_MUSIC_NAME    &H10000 ' MOD music name : ANSI string
#define BASS_TAG_MUSIC_MESSAGE &H10001 ' MOD message : ANSI string
#define BASS_TAG_MUSIC_ORDERS  &H10002 ' MOD order list : UBYTE array of pattern numbers
#define BASS_TAG_MUSIC_INST    &H10100 ' + instrument #, MOD instrument name : ANSI string
#define BASS_TAG_MUSIC_SAMPLE  &H10300 ' + sample #, MOD sample name : ANSI string

' ID3v1 tag structure
type TAG_ID3
  as zstring *  3 id 
  as zstring * 30 title
  as zstring * 30 artist
  as zstring * 30 album
  as zstring *  4 year
  as zstring * 30 comment
  as ubyte        genre
end type

' Binary APE tag structure
type TAG_APE_BINARY
  as zstring ptr key
  as any ptr     data
  as ulong       length 
end type

' BWF "bext" tag structure
type TAG_BEXT field = 1
  as zstring * 256 Description          ' description
  as zstring *  32 Originator           ' name of the originator
  as zstring *  32 OriginatorReference  ' reference of the originator
  as zstring *  10 OriginationDate      ' date of creation (yyyy-mm-dd)
  as zstring *   8 OriginationTime      ' time of creation (hh-mm-ss)
  as ULongInt         TimeReference        ' first sample count since midnight (little-endian)
  as ushort          Version              ' BWF version (little-endian)
  as ubyte         UMID(0 to 63)        ' SMPTE UMID
  as ubyte         Reserved(0 to 189)
  as zstring *   1 CodingHistory        ' history
end type

' BWF "cart" tag structures
type TAG_CART_TIMER
  as ulong dwUsage ' FOURCC timer usage ID
  as ulong dwValue ' timer value in samples from head
end type

type TAG_CART
  as zstring *  4   Version          ' version of the data structure
  as zstring * 64   Title            ' title of cart audio sequence
  as zstring * 64   Artist           ' artist or creator name
  as zstring * 64   CutID            ' cut number identification
  as zstring * 64   ClientID         ' client identification
  as zstring * 64   Category         ' category ID, PSA, NEWS, etc
  as zstring * 64   Classification   ' classification or auxiliary key
  as zstring * 64   OutCue           ' out cue text
  as zstring * 10   StartDate        ' yyyy-mm-dd
  as zstring *  8   StartTime        ' hh:mm:ss
  as zstring * 10   EndDate          ' yyyy-mm-dd
  as zstring *  8   EndTime          ' hh:mm:ss
  as zstring * 64   ProducerAppID    ' name of vendor or application
  as zstring * 64   ProducerAppVersion ' version of producer application
  as zstring * 64   UserDef          ' user defined text
  as ulong          dwLevelReference ' sample value for 0 dB reference
  as TAG_CART_TIMER PostTimer(7)     ' 8 time markers after head
  as zstring * 276  Reserved
  as zstring * 1024 URL              '  uniform resource locator
  as zstring * 1    TagText          ' free form text for scripts or tags
end type

' CoreAudio codec info structure
type TAG_CA_CODEC
  as ulong       ftype ' file format
  as ulong       atype ' audio format
  as zstring ptr name  ' description
end type

#ifndef _WAVEFORMATEX_
#define _WAVEFORMATEX_
type tWAVEFORMATEX field=1
  as ushort wFormatTag
  as ushort nChannels
  as ulong nSamplesPerSec
  as ulong nAvgBytesPerSec
  as ushort nBlockAlign
  as ushort wBitsPerSample
  as ushort cbSize
end type
type WAVEFORMATEX as tWAVEFORMATEX
type PWAVEFORMATEX as WAVEFORMATEX ptr
type LPWAVEFORMATEX as WAVEFORMATEX ptr
type LPCWAVEFORMATEX as const WAVEFORMATEX ptr
#endif

' BASS_ChannelGetLength/GetPosition/SetPosition modes
#define BASS_POS_BYTE                 0 ' byte position
#define BASS_POS_MUSIC_ORDER          1 ' order.row position, MAKELONG(order,row)
#define BASS_POS_OGG                  3 ' OGG bitstream number
#define BASS_POS_INEXACT      &H8000000 ' flag: allow seeking to inexact position
#define BASS_POS_DECODE      &H10000000 ' flag: get the decoding (not playing) position
#define BASS_POS_DECODETO    &H20000000 ' flag: decode to the position instead of seeking
#define BASS_POS_SCAN        &H40000000 ' flag: scan to the position

' BASS_RecordSetInput flags
#define BASS_INPUT_OFF          &H10000
#define BASS_INPUT_ON           &H20000

#define BASS_INPUT_TYPE_MASK    &Hff000000
#define BASS_INPUT_TYPE_UNDEF   &H00000000
#define BASS_INPUT_TYPE_DIGITAL &H01000000
#define BASS_INPUT_TYPE_LINE    &H02000000
#define BASS_INPUT_TYPE_MIC     &H03000000
#define BASS_INPUT_TYPE_SYNTH   &H04000000
#define BASS_INPUT_TYPE_CD      &H05000000
#define BASS_INPUT_TYPE_PHONE   &H06000000
#define BASS_INPUT_TYPE_SPEAKER &H07000000
#define BASS_INPUT_TYPE_WAVE    &H08000000
#define BASS_INPUT_TYPE_AUX     &H09000000
#define BASS_INPUT_TYPE_ANALOG  &H0a000000

' DX8 effect types, use with BASS_ChannelSetFX
enum
  BASS_FX_DX8_CHORUS,
  BASS_FX_DX8_COMPRESSOR,
  BASS_FX_DX8_DISTORTION,
  BASS_FX_DX8_ECHO,
  BASS_FX_DX8_FLANGER,
  BASS_FX_DX8_GARGLE,
  BASS_FX_DX8_I3DL2REVERB,
  BASS_FX_DX8_PARAMEQ,
  BASS_FX_DX8_REVERB
end enum

type BASS_DX8_CHORUS
  as single fWetDryMix
  as single fDepth
  as single fFeedback
  as single fFrequency
  as ulong  lWaveform  ' 0=triangle, 1=sine
  as single fDelay
  as ulong  lPhase     ' BASS_DX8_PHASE_xxx
end type

type BASS_DX8_COMPRESSOR
  as single  fGain
  as single  fAttack
  as single  fRelease
  as single  fThreshold 
  as single  fRatio
  as single  fPredelay
end type

type BASS_DX8_DISTORTION
  as single fGain
  as single fEdge
  as single fPostEQCenterFrequency
  as single fPostEQBandwidth
  as single fPreLowpassCutoff
end type

type BASS_DX8_ECHO
  as single fWetDryMix
  as single fFeedback
  as single fLeftDelay
  as single fRightDelay
  as ulong   lPanDelay
end type

type BASS_DX8_FLANGER
  as single fWetDryMix
  as single fDepth
  as single fFeedback
  as single fFrequency
  as ulong  lWaveform    ' 0=triangle, 1=sine
  as single fDelay 
  as ulong  lPhase       ' BASS_DX8_PHASE_xxx
end type

type BASS_DX8_GARGLE
  as ulong dwRateHz     ' Rate of modulation in hz
  as ulong dwWaveShape  ' 0=triangle, 1=square
end type

type BASS_DX8_I3DL2REVERB
  as integer lRoom               ' [-10000, 0]      default: -1000 mB
  as integer lRoomHF             ' [-10000, 0]      default: 0 mB
  as single  flRoomRolloffFactor ' [0.0, 10.0]      default: 0.0
  as single  flDecayTime         ' [0.1, 20.0]      default: 1.49s
  as single  flDecayHFRatio      ' [0.1, 2.0]       default: 0.83
  as integer lReflections        ' [-10000, 1000]   default: -2602 mB
  as single  flReflectionsDelay  ' [0.0, 0.3]       default: 0.007 s
  as integer lReverb             ' [-10000, 2000]   default: 200 mB
  as single  flReverbDelay       ' [0.0, 0.1]       default: 0.011 s
  as single  flDiffusion         ' [0.0, 100.0]     default: 100.0 %
  as single  flDensity           ' [0.0, 100.0]     default: 100.0 %
  as single  flHFReference       ' [20.0, 20000.0]  default: 5000.0 Hz
end type

type BASS_DX8_PARAMEQ
  as single fCenter
  as single fBandwidth
  as single fGain
end type

type BASS_DX8_REVERB
  as single fInGain          ' [-96.0,0.0]            default: 0.0 dB
  as single fReverbMix       ' [-96.0,0.0]            default: 0.0 db
  as single fReverbTime      ' [0.001,3000.0]         default: 1000.0 ms
  as single fHighFreqRTRatio ' [0.001,0.999]          default: 0.001
end type

#define BASS_DX8_PHASE_NEG_180 0
#define BASS_DX8_PHASE_NEG_90  1
#define BASS_DX8_PHASE_ZERO    2
#define BASS_DX8_PHASE_90      3
#define BASS_DX8_PHASE_180     4


#define DECF(_name_) type _name_##_T as function BASS_API 
#define DECS(_name_) type _name_##_T as sub BASS_API 


DECF(BASS_SetConfig)(byval dwOption as ulong, byval value as ulong) as ulong

DECF(BASS_GetConfig)(byval dwOption as ulong) as ulong
DECF(BASS_SetConfigPtr)(byval dwOption as ulong, byval value as any ptr) as ulong
DECF(BASS_GetConfigPtr)(byval dwOption as ulong) as any ptr

DECF(BASS_ErrorGetCode) as integer
DECF(BASS_GetDeviceInfo)(byval device as ulong, byval info as BASS_DEVICEINFO ptr) as ulong
#ifdef __FB_WIN32__
DECF(BASS_GetDSoundObject)(byval dwobject as ulong) as any ptr
DECF(BASS_SetEAXParameters)(byval env as ulong,byval vol as single,byval decay as single,byval damp as single) as ulong
DECF(BASS_GetEAXParameters)(byval env as ulong ptr,byval vol as single ptr,byval decay as single ptr,byval damp as single ptr) as ulong
#endif
DECF(BASS_Init)(byval device as integer=-1, byval freq as ulong=44100, byval flags as ulong=BASS_DEVICE_FREQ, byval win as any ptr=0, byval dsguid as any ptr=0) as ulong

DECF(BASS_GetVersion) as ulong
DECF(BASS_SetDevice)(byval device as ulong) as ulong
DECF(BASS_GetDevice) as ulong
DECF(BASS_Free) as ulong
DECF(BASS_GetInfo)(byval info as BASS_INFO ptr) as ulong
DECF(BASS_Update)(byval length as ulong) as ulong
DECF(BASS_GetCPU) as single

DECF(BASS_Start) as ulong
DECF(BASS_Stop) as ulong
DECF(BASS_Pause) as ulong

DECF(BASS_SetVolume)(byval volume as single) as ulong
DECF(BASS_GetVolume) as single

DECF(BASS_PluginLoad)(byval file as zstring ptr, byval flags as ulong) as HPLUGIN
DECF(BASS_PluginFree)(byval handle as HPLUGIN) as ulong
DECF(BASS_PluginGetInfo)(byval handle as HPLUGIN) as BASS_PLUGININFO ptr

DECF(BASS_Set3DFactors)(byval distf as single=1.0, byval rollf as single=1.0, byval doppf as single=1.0) as ulong
DECF(BASS_Get3DFactors)(byval distf as single ptr, byval rollf as single ptr, byval doppf as single ptr) as ulong
DECF(BASS_Set3DPosition)(byval pos as BASS_3DVECTOR ptr, byval vel as BASS_3DVECTOR ptr, byval front as BASS_3DVECTOR ptr, byval top as BASS_3DVECTOR ptr) as ulong
DECF(BASS_Get3DPosition)(byval pos as BASS_3DVECTOR ptr, byval vel as BASS_3DVECTOR ptr, byval front as BASS_3DVECTOR ptr, byval top as BASS_3DVECTOR ptr) as ulong
DECS(BASS_Apply3D)

DECF(BASS_MusicLoad)(byval mem as ulong, byval file as any ptr, byval offset as ULongInt, byval length as ulong, byval flags as ulong, byval freq as ulong) as HMUSIC
DECF(BASS_MusicFree)(byval handle as HMUSIC) as ulong

DECF(BASS_SampleLoad)(byval mem as ulong, byval file as any ptr, byval offset as ULongInt, byval length as ulong, byval max as ulong, byval flags as ulong) as HSAMPLE
DECF(BASS_SampleCreate)(byval length as ulong, byval freq as ulong, byval chans as ulong, byval max as ulong, byval flags as ulong) as HSAMPLE
DECF(BASS_SampleFree)(byval handle as HSAMPLE) as ulong

DECF(BASS_SampleSetData)(byval handle as HSAMPLE, byval buffer as any ptr) as ulong
DECF(BASS_SampleGetData)(byval handle as HSAMPLE, byval buffer as any ptr) as ulong
DECF(BASS_SampleGetInfo)(byval handle as HSAMPLE, byval info as BASS_SAMPLE ptr) as ulong
DECF(BASS_SampleSetInfo)(byval handle as HSAMPLE, byval info as BASS_SAMPLE ptr) as ulong
DECF(BASS_SampleGetChannel)(byval handle as HSAMPLE, byval onlynew as ulong) as HCHANNEL
DECF(BASS_SampleGetChannels)(byval handle as HSAMPLE, byval channels as HCHANNEL ptr) as ulong
DECF(BASS_SampleStop)(byval handle as HSAMPLE) as ulong

DECF(BASS_StreamCreate)(byval freq as ulong, byval chans as ulong, byval flags as ulong, byval proc as STREAMPROC, byval user as any ptr) as HSTREAM
DECF(BASS_StreamCreateFile)(byval mem as ulong, byval file as any ptr, byval offset as ULongInt, byval length as ULongInt, byval flags as ulong) as HSTREAM
DECF(BASS_StreamCreateURL)(byval url as zstring ptr, byval offset as ulong, byval flags as ulong, byval proc as DOWNLOADPROC, byval user as any ptr) as HSTREAM
DECF(BASS_StreamCreateFileUser)(byval system as ulong, byval flags as ulong, byref procs as BASS_FILEPROCS, byval user as any ptr) as HSTREAM
DECF(BASS_StreamFree)(byval handle as HSTREAM) as ulong
DECF(BASS_StreamGetFilePosition)(byval handle as HSTREAM, byval mode as ulong) as ULongInt
DECF(BASS_StreamPutData)(byval handle as HSTREAM, byval buffer as any ptr, byval length as ulong) as ulong
DECF(BASS_StreamPutFileData)(byval handle as HSTREAM, byval buffer as any ptr, byval length as ulong) as ulong

DECF(BASS_RecordGetDeviceInfo)(byval device as ulong, byval info as BASS_DEVICEINFO ptr) as ulong
DECF(BASS_RecordInit)(byval device as integer) as ulong
DECF(BASS_RecordSetDevice)(byval device as ulong) as ulong
DECF(BASS_RecordGetDevice) as ulong
DECF(BASS_RecordFree) as ulong
DECF(BASS_RecordGetInfo)(byval info as BASS_RECORDINFO ptr) as ulong
DECF(BASS_RecordGetInputName)(byval input as integer) as zstring ptr
DECF(BASS_RecordSetInput)(byval input as integer, byval flags as ulong, byval volume as single) as ulong
DECF(BASS_RecordGetInput)(byval input as integer, byval volume as single ptr) as ulong
DECF(BASS_RecordStart)(byval freq as ulong, byval chans as ulong, byval flags as ulong, byval proc as RECORDPROC, byval user as any ptr) as HRECORD

DECF(BASS_ChannelBytes2Seconds)(byval handle as ulong, byval pos as ULongInt) as double
DECF(BASS_ChannelSeconds2Bytes)(byval handle as ulong, byval pos as double) as ULongInt
DECF(BASS_ChannelGetDevice)(byval handle as ulong) as ulong
DECF(BASS_ChannelSetDevice)(byval handle as ulong, byval device as ulong) as ulong
DECF(BASS_ChannelIsActive)(byval handle as ulong) as ulong
DECF(BASS_ChannelGetInfo)(byval handle as ulong, byval info as BASS_CHANNELINFO ptr) as ulong
DECF(BASS_ChannelGetTags)(byval handle as ulong, byval tags as ulong) as zstring ptr
DECF(BASS_ChannelFlags)(byval handle as ulong, byval flags as ulong, byval mask as ulong) as ulong
DECF(BASS_ChannelUpdate)(byval handle as ulong, byval length as ulong) as ulong
DECF(BASS_ChannelLock)(byval handle as ulong, byval lock as ulong) as ulong
DECF(BASS_ChannelPlay)(byval handle as ulong, byval restart as ulong) as ulong
DECF(BASS_ChannelStop)(byval handle as ulong) as ulong
DECF(BASS_ChannelPause)(byval handle as ulong) as ulong
DECF(BASS_ChannelSetAttribute)(byval handle as ulong, byval attrib as ulong, byval value as single) as ulong
DECF(BASS_ChannelGetAttribute)(byval handle as ulong, byval attrib as ulong, byval value as single ptr) as ulong
DECF(BASS_ChannelSlideAttribute)(byval handle as ulong, byval attrib as ulong, byval value as single, byval time as ulong) as ulong
DECF(BASS_ChannelIsSliding)(byval handle as ulong, byval attrib as ulong) as ulong
DECF(BASS_ChannelSet3DAttributes)(byval handle as ulong, byval mode as integer, byval min as single, byval max as single, byval iangle as integer, byval oangle as integer, byval outvol as single) as ulong
DECF(BASS_ChannelGet3DAttributes)(byval handle as ulong, byval mode as ulong ptr, byval min as single ptr, byval max as single ptr, byval iangle as ulong ptr, byval oangle as ulong ptr, byval outvol as single ptr) as ulong
DECF(BASS_ChannelSet3DPosition)(byval handle as ulong, byval pos as BASS_3DVECTOR ptr, byval orient as BASS_3DVECTOR ptr, byval vel as BASS_3DVECTOR ptr) as ulong
DECF(BASS_ChannelGet3DPosition)(byval handle as ulong, byval pos as BASS_3DVECTOR ptr, byval orient as BASS_3DVECTOR ptr, byval vel as BASS_3DVECTOR ptr) as ulong
DECF(BASS_ChannelGetLength)(byval handle as ulong, byval mode as ulong) as ULongInt
DECF(BASS_ChannelSetPosition)(byval handle as ulong, byval pos as ULongInt, byval mode as ulong) as ulong
DECF(BASS_ChannelGetPosition)(byval handle as ulong, byval mode as ulong) as ULongInt
DECF(BASS_ChannelGetLevel)(byval handle as ulong) as ulong
DECF(BASS_ChannelGetData)(byval handle as ulong, byval buffer as any ptr, byval length as ulong) as ulong
DECF(BASS_ChannelSetSync)(byval handle as ulong, byval type as ulong, byval param as ULongInt, byval proc as SYNCPROC, byval user as any ptr) as HSYNC
DECF(BASS_ChannelRemoveSync)(byval handle as ulong, byval sync as HSYNC) as ulong
DECF(BASS_ChannelSetDSP)(byval handle as ulong, byval proc as DSPPROC, byval user as any ptr, byval priority as integer) as HDSP
DECF(BASS_ChannelRemoveDSP)(byval handle as ulong, byval dsp as HDSP) as ulong
DECF(BASS_ChannelSetLink)(byval handle as ulong, byval chan as ulong) as ulong
DECF(BASS_ChannelRemoveLink)(byval handle as ulong, byval chan as ulong) as ulong
DECF(BASS_ChannelSetFX)(byval handle as ulong, byval type as ulong, byval priority as integer) as HFX
DECF(BASS_ChannelRemoveFX)(byval handle as ulong, byval fx as HFX) as ulong

DECF(BASS_FXSetParameters)(byval handle as HFX, byval params as any ptr) as ulong
DECF(BASS_FXGetParameters)(byval handle as HFX, byval params as any ptr) as ulong
DECF(BASS_FXReset)(byval handle as HFX) as ulong

#undef DECF
#undef DECS

type BASS_T
  declare destructor
  declare constructor
  declare function GetVersionsString as string 
  declare function IsErrorOnLoad as integer
  declare function GetErrorString as String
  #define DEFBASS(_name_) as BASS_##_name_##_T _name_
  DEFBASS(SetConfig)
  DEFBASS(GetConfig)
  DEFBASS(SetConfigPtr)
  DEFBASS(GetConfigPtr)
  DEFBASS(ErrorGetCode)
  DEFBASS(GetDeviceInfo)
  #ifdef __FB_WIN32__
  DEFBASS(GetDSoundObject)
  DEFBASS(SetEAXParameters)
  DEFBASS(GetEAXParameters)
  #endif
  DEFBASS(Init)
  DEFBASS(Free)

  DEFBASS(GetVersion)
  DEFBASS(SetDevice)
  DEFBASS(GetDevice)
  DEFBASS(GetInfo)

  DEFBASS(Update)
  DEFBASS(GetCPU)

  DEFBASS(Start)
  DEFBASS(Stop)
  DEFBASS(Pause)

  DEFBASS(SetVolume)
  DEFBASS(GetVolume)

  DEFBASS(PluginLoad)
  DEFBASS(PluginFree)
  DEFBASS(PluginGetInfo)

  DEFBASS(Set3DFactors)
  DEFBASS(Get3DFactors)
  DEFBASS(Set3DPosition)
  DEFBASS(Get3DPosition)
  DEFBASS(Apply3D)

  DEFBASS(MusicLoad)
  DEFBASS(MusicFree)

  DEFBASS(SampleLoad)
  DEFBASS(SampleCreate)
  DEFBASS(SampleFree)
  DEFBASS(SampleSetData)
  DEFBASS(SampleGetData)
  DEFBASS(SampleGetInfo)
  DEFBASS(SampleSetInfo)
  DEFBASS(SampleGetChannel)
  DEFBASS(SampleGetChannels)
  DEFBASS(SampleStop)

  DEFBASS(StreamCreate)
  DEFBASS(StreamCreateFile)
  DEFBASS(StreamCreateURL)
  DEFBASS(StreamCreateFileUser)
  DEFBASS(StreamFree)
  DEFBASS(StreamGetFilePosition)
  DEFBASS(StreamPutData)
  DEFBASS(StreamPutFileData)

  DEFBASS(RecordGetDeviceInfo)
  DEFBASS(RecordInit)
  DEFBASS(RecordSetDevice)
  DEFBASS(RecordGetDevice)
  DEFBASS(RecordFree)
  DEFBASS(RecordGetInfo)
  DEFBASS(RecordGetInputName)
  DEFBASS(RecordSetInput)
  DEFBASS(RecordGetInput)
  DEFBASS(RecordStart)

  DEFBASS(ChannelBytes2Seconds)
  DEFBASS(ChannelSeconds2Bytes)
  DEFBASS(ChannelGetDevice)
  DEFBASS(ChannelSetDevice)
  DEFBASS(ChannelIsActive)
  DEFBASS(ChannelGetInfo)
  DEFBASS(ChannelGetTags)
  DEFBASS(ChannelFlags)
  DEFBASS(ChannelUpdate)
  DEFBASS(ChannelLock)
  DEFBASS(ChannelPlay)
  DEFBASS(ChannelStop)
  DEFBASS(ChannelPause)
  DEFBASS(ChannelSetAttribute)
  DEFBASS(ChannelGetAttribute)
  DEFBASS(ChannelSlideAttribute)
  DEFBASS(ChannelIsSliding)
  DEFBASS(ChannelSet3DAttributes)
  DEFBASS(ChannelGet3DAttributes)
  DEFBASS(ChannelSet3DPosition)
  DEFBASS(ChannelGet3DPosition)
  DEFBASS(ChannelGetLength)
  DEFBASS(ChannelSetPosition)
  DEFBASS(ChannelGetPosition)
  DEFBASS(ChannelGetLevel)
  DEFBASS(ChannelGetData)
  DEFBASS(ChannelSetSync)
  DEFBASS(ChannelRemoveSync)
  DEFBASS(ChannelSetDSP)
  DEFBASS(ChannelRemoveDSP)
  DEFBASS(ChannelSetLink)
  DEFBASS(ChannelRemoveLink)
  DEFBASS(ChannelSetFX)
  DEFBASS(ChannelRemoveFX)

  DEFBASS(FXSetParameters)
  DEFBASS(FXGetParameters)
  DEFBASS(FXReset)
  #undef DEFBASS
  private:
  as any ptr mhLib
  as integer mError
end type



#endif ' __LIBBASS_BI__

