#ifdef __LIBBASMIX_BAS__

#error 666: included twice !

#else

#define __LIBBASMIX_BAS__

#include once "libbassmix.bi"

type BASSMIX_T
  declare destructor
  declare constructor
  declare function GetVersionsString as string 
  declare function IsErrorOnLoad as integer
  declare function GetErrorString as String
  #define DEFBASSMIX(_name_) as BASS_Mixer_##_name_##_T _name_
  DEFBASSMIX(GetVersion)
  DEFBASSMIX(StreamCreate)
  DEFBASSMIX(StreamAddChannel)
  DEFBASSMIX(StreamAddChannelEx)
  DEFBASSMIX(ChannelGetMixer)
  DEFBASSMIX(ChannelFlags)
  DEFBASSMIX(ChannelRemove)
  DEFBASSMIX(ChannelSetPosition)
  DEFBASSMIX(ChannelGetPosition)
  DEFBASSMIX(ChannelGetPositionEx)
  DEFBASSMIX(ChannelGetLevel)
  DEFBASSMIX(ChannelGetLevelEx)
  DEFBASSMIX(ChannelGetData)
  DEFBASSMIX(ChannelSetSync)
  DEFBASSMIX(ChannelRemoveSync)
  DEFBASSMIX(ChannelSetMatrix)
  DEFBASSMIX(ChannelSetMatrixEx)
  DEFBASSMIX(ChannelGetMatrix)
  DEFBASSMIX(ChannelSetEnvelope)
  DEFBASSMIX(ChannelSetEnvelopePos)
  DEFBASSMIX(ChannelGetEnvelopePos)
  #undef DEFBASSMIX

  #define DEFBASSSPLIT(_name_) as BASS_##_name_##_T _name_
  DEFBASSSPLIT(Split_StreamCreate)
  DEFBASSSPLIT(Split_StreamGetSource)
  DEFBASSSPLIT(Split_StreamGetSplits)
  DEFBASSSPLIT(Split_StreamReset)
  DEFBASSSPLIT(Split_StreamResetEx)
  DEFBASSSPLIT(Split_StreamGetAvailable)
  #undef DEFBASSSPLIT
  private:
  as any ptr mhLib
  as integer mError
end type

function BASSMIX_T.GetVersionsString as string 
  if this.mError then return "BassMix no version error: loading " & BASSMIX_LIB_NAME
  dim as ulong ver = this.GetVersion()
  return "BassMix version " & hibyte(hiword(ver)) & "." & lobyte(hiword(ver))
end function

function BASSMIX_T.IsErrorOnLoad as integer
  return (mError<>0)
end function

destructor BASSMIX_T
  if mhLib then
    dylibfree mhLib : mhLib=0
  end if
end destructor

constructor BASSMIX_T
  mError=0
  mhLib=dylibload(BASSMIX_LIB_NAME)
  if mhLib=0 then mError=1
  if mError=0 then
  #define DEFBASSMIX(_name_) _name_ =  DyLibSymbol(mhLib, "BASS_Mixer_" & #_name_) : if _name_=0 then mError=1
  DEFBASSMIX(GetVersion)
  DEFBASSMIX(StreamCreate)
  DEFBASSMIX(StreamAddChannel)
  DEFBASSMIX(StreamAddChannelEx)
  DEFBASSMIX(ChannelGetMixer)
  DEFBASSMIX(ChannelFlags)
  DEFBASSMIX(ChannelRemove)
  DEFBASSMIX(ChannelSetPosition)
  DEFBASSMIX(ChannelGetPosition)
  DEFBASSMIX(ChannelGetPositionEx)
  DEFBASSMIX(ChannelGetLevel)
  DEFBASSMIX(ChannelGetLevelEx)
  DEFBASSMIX(ChannelGetData)
  DEFBASSMIX(ChannelSetSync)
  DEFBASSMIX(ChannelRemoveSync)
  DEFBASSMIX(ChannelSetMatrix)
  DEFBASSMIX(ChannelSetMatrixEx)
  DEFBASSMIX(ChannelGetMatrix)
  DEFBASSMIX(ChannelSetEnvelope)
  DEFBASSMIX(ChannelSetEnvelopePos)
  DEFBASSMIX(ChannelGetEnvelopePos)
  #undef DEFBASSMIX

  #define DEFBASSSPLIT(_name_) _name_ =  DyLibSymbol(mhLib, "BASS_" & #_name_) : if _name_=0 then mError=1
  DEFBASSSPLIT(Split_StreamCreate)
  DEFBASSSPLIT(Split_StreamGetSource)
  DEFBASSSPLIT(Split_StreamGetSplits)
  DEFBASSSPLIT(Split_StreamReset)
  DEFBASSSPLIT(Split_StreamResetEx)
  DEFBASSSPLIT(Split_StreamGetAvailable)
  #undef DEFBASSSPLIT
  end if
end constructor
dim shared as BASSMIX_T BASSMIX
#endif ' __LIBBASMIX_BAS__