#ifndef __LIBBASSMIX_BI__
#define __LIBBASSMIX_BI__

/'
  BASSmix 2.4 C/C++ header file
  Copyright (c) 2005-2015 Un4seen Developments Ltd.

  See the BASSMIX.CHM file for more detailed documentation
'/

' libBASSMIX dsynamic loader 2.4 FreeBASIC header file
' Copyright (c) 2015 Shiny3D.

#include once "libbass.bi"

#if (BASSVERSION<>&H204)
#error conflicting BASS and BASSMIX versions
#endif

#ifdef __FB_WIN32__
 #ifndef __FB_64BIT__
  #define BASSMIX_LIB_NAME "win32/bassmix.dll"
 #else
  #define BASSMIX_LIB_NAME "win64/bassmix.dll"
 #endif
#else
 #ifndef __FB_64BIT__
  #define BASSMIX_LIB_NAME "linux32/libbassmix.so"
 #else
  #define BASSMIX_LIB_NAME "linux64/libbassmix.so"
 #endif
#endif

#ifndef BASSMIXDEF
#define BASSMIXDEF(f) WINAPI f
#endif

' additional BASS_SetConfig option
#define BASS_CONFIG_MIXER_BUFFER &H10601
#define BASS_CONFIG_MIXER_POSEX  &H10602
#define BASS_CONFIG_SPLIT_BUFFER &H10610

' BASS_Mixer_StreamCreate flags
#define BASS_MIXER_END       &H10000 ' end the stream when there are no sources
#define BASS_MIXER_NONSTOP   &H20000 ' don't stall when there are no sources
#define BASS_MIXER_RESUME     &H1000 ' resume stalled immediately upon new/unpaused source
#define BASS_MIXER_POSEX      &H2000 ' enable BASS_Mixer_ChannelGetPositionEx support

' source flags
#define BASS_MIXER_BUFFER     &H2000 ' buffer data for BASS_Mixer_ChannelGetData/Level
#define BASS_MIXER_LIMIT      &H4000 ' limit mixer processing to the amount available from this source
#define BASS_MIXER_MATRIX    &H10000 ' matrix mixing
#define BASS_MIXER_PAUSE     &H20000 ' don't process the source
#define BASS_MIXER_DOWNMIX  &H400000 ' downmix to stereo/mono
#define BASS_MIXER_NORAMPIN &H800000 ' don't ramp-in the start

' mixer attributes
#define BASS_ATTRIB_MIXER_LATENCY  &H15000

' splitter flags
#define BASS_SPLIT_SLAVE    &H1000  ' only read buffered data

' envelope node
type BASS_MIXER_NODE
  as ULongInt  pos
  as single value
end type

' envelope types
#define BASS_MIXER_ENV_FREQ   1
#define BASS_MIXER_ENV_VOL    2
#define BASS_MIXER_ENV_PAN    3
#define BASS_MIXER_ENV_LOOP   &H10000 ' FLAG: loop

' additional sync type
#define BASS_SYNC_MIXER_ENVELOPE    &H10200
#define BASS_SYNC_MIXER_ENVELOPE_NODE  &H10201

' BASS_CHANNELINFO type
#define BASS_CTYPE_STREAM_MIXER  &H10800
#define BASS_CTYPE_STREAM_SPLIT  &H10801

#define DECF(_name_) type _name_##_T as function BASS_API 
DECF(BASS_Mixer_GetVersion) as ulong
DECF(BASS_Mixer_StreamCreate)(byval freq as ulong,byval chans as ulong,byval flags as ulong) as HSTREAM
DECF(BASS_Mixer_StreamAddChannel)(byval handle as HSTREAM,byval channel as ulong,byval flags as ulong) as ulong
DECF(BASS_Mixer_StreamAddChannelEx)(byval handle as HSTREAM,byval channel as ulong,byval flags as ulong,byval start as ULongInt,byval length as ULongInt) as ulong
DECF(BASS_Mixer_ChannelGetMixer)(byval handle as ulong) as HSTREAM
DECF(BASS_Mixer_ChannelFlags)(byval handle as ulong,byval flags as ulong,byval mask as ulong) as ulong
DECF(BASS_Mixer_ChannelRemove)(byval handle as ulong) as ulong
DECF(BASS_Mixer_ChannelSetPosition)(byval handle as ulong,byval pos as ULongInt,byval mode as ulong) as ulong
DECF(BASS_Mixer_ChannelGetPosition)(byval handle as ulong,byval mode as ulong) as ULongInt
DECF(BASS_Mixer_ChannelGetPositionEx)(byval channel as ulong,byval mode as ulong,byval delay as ulong) as ULongInt
DECF(BASS_Mixer_ChannelGetLevel)(byval handle as ulong) as ulong
DECF(BASS_Mixer_ChannelGetLevelEx)(byval handle as ulong,byval levels as single ptr,byval length as single, byval flags as ulong) as ulong
DECF(BASS_Mixer_ChannelGetData)(byval handle as ulong,byval buffer as any ptr,byval length as ulong) as ulong
DECF(BASS_Mixer_ChannelSetSync)(byval handle as ulong,byval type as ulong,byval param as ULongInt,byval proc as SYNCPROC,byval user as any ptr) as HSYNC
DECF(BASS_Mixer_ChannelRemoveSync)(byval channel as ulong,byval sync as HSYNC) as ulong
DECF(BASS_Mixer_ChannelSetMatrix)(byval handle as ulong,byval matrix as const any ptr) as ulong
DECF(BASS_Mixer_ChannelSetMatrixEx)(byval handle as ulong,byval matrix as const any ptr,byval time as single) as ulong
DECF(BASS_Mixer_ChannelGetMatrix)(byval handle as ulong,byval matrix as any ptr) as ulong
DECF(BASS_Mixer_ChannelSetEnvelope)(byval handle as ulong,byval type as ulong,byval nodes as const BASS_MIXER_NODE ptr,byval count as ulong) as ulong
DECF(BASS_Mixer_ChannelSetEnvelopePos)(byval handle as ulong,byval type as ulong,byval pos as ULongInt) as ulong
DECF(BASS_Mixer_ChannelGetEnvelopePos)(byval handle as ulong,byval type as ulong,byval value as single ptr) as ULongInt

DECF(BASS_Split_StreamCreate)(byval channel as ulong, byval flags as ulong,byval chanmap as integer ptr) as HSTREAM
DECF(BASS_Split_StreamGetSource)(byval handle as HSTREAM) as ulong
DECF(BASS_Split_StreamGetSplits)(byval handle as ulong,byval splites as HSTREAM ptr,byval count as ulong) as ulong
DECF(BASS_Split_StreamReset)(byval handle as ulong) as ulong
DECF(BASS_Split_StreamResetEx)(byval handle as ulong,byval offset as ulong) as ulong
DECF(BASS_Split_StreamGetAvailable)(byval handle as ulong) as ulong
#undef DECF

#endif ' __LIBBASSMIX_BI__
